common: capture metadump output if xfs filesystem check fails
[xfstests-dev.git] / common / xfs
1 #
2 # XFS specific common functions.
3 #
4
5 _setup_large_xfs_fs()
6 {
7         fs_size=$1
8         local tmp_dir=/tmp/
9
10         [ "$LARGE_SCRATCH_DEV" != yes ] && return 0
11         [ -z "$SCRATCH_DEV_EMPTY_SPACE" ] && SCRATCH_DEV_EMPTY_SPACE=0
12         [ $SCRATCH_DEV_EMPTY_SPACE -ge $fs_size ] && return 0
13
14         # calculate the size of the file we need to allocate.
15         # Default free space in the FS is 50GB, but you can specify more via
16         # SCRATCH_DEV_EMPTY_SPACE
17         file_size=$(($fs_size - 50*1024*1024*1024))
18         file_size=$(($file_size - $SCRATCH_DEV_EMPTY_SPACE))
19
20         # mount the filesystem, create the file, unmount it
21         _try_scratch_mount 2>&1 >$tmp_dir/mnt.err
22         local status=$?
23         if [ $status -ne 0 ]; then
24                 echo "mount failed"
25                 cat $tmp_dir/mnt.err >&2
26                 rm -f $tmp_dir/mnt.err
27                 return $status
28         fi
29         rm -f $tmp_dir/mnt.err
30
31         xfs_io -F -f \
32                 -c "truncate $file_size" \
33                 -c "falloc -k 0 $file_size" \
34                 -c "chattr +d" \
35                 $SCRATCH_MNT/.use_space 2>&1 > /dev/null
36         export NUM_SPACE_FILES=1
37         status=$?
38         _scratch_unmount
39         if [ $status -ne 0 ]; then
40                 echo "large file prealloc failed"
41                 cat $tmp_dir/mnt.err >&2
42                 return $status
43         fi
44         return 0
45 }
46
47 _scratch_mkfs_xfs_opts()
48 {
49         mkfs_opts=$*
50
51         # remove metadata related mkfs options if mkfs.xfs doesn't them
52         if [ -n "$XFS_MKFS_HAS_NO_META_SUPPORT" ]; then
53                 mkfs_opts=`echo $mkfs_opts | sed "s/-m\s\+\S\+//g"`
54         fi
55
56         _scratch_options mkfs
57
58         echo "$MKFS_XFS_PROG $SCRATCH_OPTIONS $mkfs_opts"
59 }
60
61
62 _scratch_mkfs_xfs_supported()
63 {
64         local mkfs_opts=$*
65
66         _scratch_options mkfs
67
68         $MKFS_XFS_PROG -N $MKFS_OPTIONS $SCRATCH_OPTIONS $mkfs_opts $SCRATCH_DEV
69         local mkfs_status=$?
70
71         # a mkfs failure may be caused by conflicts between $MKFS_OPTIONS and
72         # $mkfs_opts, try again without $MKFS_OPTIONS
73         if [ $mkfs_status -ne 0 -a -n "$mkfs_opts" ]; then
74                 $MKFS_XFS_PROG -N $SCRATCH_OPTIONS $mkfs_opts $SCRATCH_DEV
75                 mkfs_status=$?
76         fi
77         return $mkfs_status
78 }
79
80 # Returns the minimum XFS log size, in units of log blocks.
81 _scratch_find_xfs_min_logblocks()
82 {
83         local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
84
85         # The smallest log size we can specify is 2M (XFS_MIN_LOG_BYTES) so
86         # pass that in and see if mkfs succeeds or tells us what is the
87         # minimum log size.
88         local XFS_MIN_LOG_BYTES=2097152
89
90         # Try formatting the filesystem with all the options given and the
91         # minimum log size.  We hope either that this succeeds or that mkfs
92         # tells us the required minimum log size for the feature set.
93         #
94         # We cannot use _scratch_do_mkfs because it will retry /any/ failed
95         # mkfs with MKFS_OPTIONS removed even if the only "failure" was that
96         # the log was too small.
97         local extra_mkfs_options="$* -N -l size=$XFS_MIN_LOG_BYTES"
98         eval "$mkfs_cmd $MKFS_OPTIONS $extra_mkfs_options $SCRATCH_DEV" \
99                 2>$tmp.mkfserr 1>$tmp.mkfsstd
100         local mkfs_status=$?
101
102         # If the format fails for a reason other than the log being too small,
103         # try again without MKFS_OPTIONS because that's what _scratch_do_mkfs
104         # will do if we pass in the log size option.
105         if [ $mkfs_status -ne 0 ] &&
106            ! egrep -q '(log size.*too small, minimum|external log device.*too small, must be)' $tmp.mkfserr; then
107                 eval "$mkfs_cmd $extra_mkfs_options $SCRATCH_DEV" \
108                         2>$tmp.mkfserr 1>$tmp.mkfsstd
109                 mkfs_status=$?
110         fi
111
112         # mkfs suceeded, so we must pick out the log block size to do the
113         # unit conversion
114         if [ $mkfs_status -eq 0 ]; then
115                 blksz="$(grep '^log.*bsize' $tmp.mkfsstd | \
116                         sed -e 's/log.*bsize=\([0-9]*\).*$/\1/g')"
117                 echo $((XFS_MIN_LOG_BYTES / blksz))
118                 rm -f $tmp.mkfsstd $tmp.mkfserr
119                 return
120         fi
121
122         # Usually mkfs will tell us the minimum log size...
123         if grep -q 'minimum size is' $tmp.mkfserr; then
124                 grep 'minimum size is' $tmp.mkfserr | \
125                         sed -e 's/^.*minimum size is \([0-9]*\) blocks/\1/g'
126                 rm -f $tmp.mkfsstd $tmp.mkfserr
127                 return
128         fi
129         if grep -q 'external log device.*too small, must be' $tmp.mkfserr; then
130                 grep 'external log device.*too small, must be' $tmp.mkfserr | \
131                         sed -e 's/^.*must be at least \([0-9]*\) blocks/\1/g'
132                 rm -f $tmp.mkfsstd $tmp.mkfserr
133                 return
134         fi
135
136         # Don't know what to do, so fail
137         echo "Cannot determine minimum log size" >&2
138         cat $tmp.mkfsstd >> $seqres.full
139         cat $tmp.mkfserr >> $seqres.full
140         rm -f $tmp.mkfsstd $tmp.mkfserr
141 }
142
143 _scratch_mkfs_xfs()
144 {
145         local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
146         local mkfs_filter="sed -e '/less than device physical sector/d' \
147                                -e '/switching to logical sector/d' \
148                                -e '/Default configuration/d'"
149         local tmp=`mktemp -u`
150         local mkfs_status
151
152         _scratch_do_mkfs "$mkfs_cmd" "$mkfs_filter" $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
153         mkfs_status=$?
154
155         grep -q crc=0 $tmp.mkfsstd && _force_xfsv4_mount_options
156
157         if [ $mkfs_status -eq 0 -a "$LARGE_SCRATCH_DEV" = yes ]; then
158                 # manually parse the mkfs output to get the fs size in bytes
159                 local fs_size
160                 fs_size=`cat $tmp.mkfsstd | perl -ne '
161                         if (/^data\s+=\s+bsize=(\d+)\s+blocks=(\d+)/) {
162                                 my $size = $1 * $2;
163                                 print STDOUT "$size\n";
164                         }'`
165                 _setup_large_xfs_fs $fs_size
166                 mkfs_status=$?
167         fi
168
169         # output mkfs stdout and stderr
170         cat $tmp.mkfsstd
171         cat $tmp.mkfserr >&2
172         rm -f $tmp.mkfserr $tmp.mkfsstd
173
174         return $mkfs_status
175 }
176
177 # Get the size of an allocation unit of a file.  Normally this is just the
178 # block size of the file, but for realtime files, this is the realtime extent
179 # size.
180 _xfs_get_file_block_size()
181 {
182         local path="$1"
183
184         if ! ($XFS_IO_PROG -c "stat -v" "$path" 2>&1 | egrep -q '(rt-inherit|realtime)'); then
185                 _get_block_size "$path"
186                 return
187         fi
188
189         # Otherwise, call xfs_info until we find a mount point or the root.
190         path="$(readlink -m "$path")"
191         while ! $XFS_INFO_PROG "$path" &>/dev/null && [ "$path" != "/" ]; do
192                 path="$(dirname "$path")"
193         done
194         $XFS_INFO_PROG "$path" | grep realtime | sed -e 's/^.*extsz=\([0-9]*\).*$/\1/g'
195 }
196
197 # xfs_check script is planned to be deprecated. But, we want to
198 # be able to invoke "xfs_check" behavior in xfstests in order to
199 # maintain the current verification levels.
200 _xfs_check()
201 {
202         OPTS=" "
203         DBOPTS=" "
204         USAGE="Usage: xfs_check [-fsvV] [-l logdev] [-i ino]... [-b bno]... special"
205
206         OPTIND=1
207         while getopts "b:fi:l:stvV" c; do
208                 case $c in
209                         s) OPTS=$OPTS"-s ";;
210                         t) OPTS=$OPTS"-t ";;
211                         v) OPTS=$OPTS"-v ";;
212                         i) OPTS=$OPTS"-i "$OPTARG" ";;
213                         b) OPTS=$OPTS"-b "$OPTARG" ";;
214                         f) DBOPTS=$DBOPTS" -f";;
215                         l) DBOPTS=$DBOPTS" -l "$OPTARG" ";;
216                         V) $XFS_DB_PROG -p xfs_check -V
217                            return $?
218                            ;;
219                 esac
220         done
221         set -- extra $@
222         shift $OPTIND
223         case $# in
224                 1) ${XFS_DB_PROG}${DBOPTS} -F -i -p xfs_check -c "check$OPTS" $1
225                    status=$?
226                    ;;
227                 2) echo $USAGE 1>&1
228                    status=2
229                    ;;
230         esac
231         return $status
232 }
233
234 _scratch_xfs_db_options()
235 {
236         SCRATCH_OPTIONS=""
237         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
238                 SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
239         echo $SCRATCH_OPTIONS $* $SCRATCH_DEV
240 }
241
242 _scratch_xfs_db()
243 {
244         $XFS_DB_PROG "$@" $(_scratch_xfs_db_options)
245 }
246
247 _test_xfs_db_options()
248 {
249         TEST_OPTIONS=""
250         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
251                 TEST_OPTIONS="-l$TEST_LOGDEV"
252         echo $TEST_OPTIONS $* $TEST_DEV
253 }
254
255 _test_xfs_db()
256 {
257         $XFS_DB_PROG "$@" $(_test_xfs_db_options)
258 }
259
260 _scratch_xfs_admin()
261 {
262         local options=("$SCRATCH_DEV")
263         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
264                 options+=("$SCRATCH_LOGDEV")
265         $XFS_ADMIN_PROG "$@" "${options[@]}"
266 }
267
268 _scratch_xfs_logprint()
269 {
270         SCRATCH_OPTIONS=""
271         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
272                 SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
273         $XFS_LOGPRINT_PROG $SCRATCH_OPTIONS $* $SCRATCH_DEV
274 }
275
276 _test_xfs_logprint()
277 {
278         TEST_OPTIONS=""
279         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
280                 TEST_OPTIONS="-l$TEST_LOGDEV"
281         $XFS_LOGPRINT_PROG $TEST_OPTIONS $* $TEST_DEV
282 }
283
284 _scratch_xfs_check()
285 {
286         SCRATCH_OPTIONS=""
287         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
288                 SCRATCH_OPTIONS="-l $SCRATCH_LOGDEV"
289         [ "$LARGE_SCRATCH_DEV" = yes ] && \
290                 SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -t"
291         _xfs_check $SCRATCH_OPTIONS $* $SCRATCH_DEV
292 }
293
294 _scratch_xfs_repair()
295 {
296         SCRATCH_OPTIONS=""
297         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
298                 SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
299         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_RTDEV" ] && \
300                 SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -r$SCRATCH_RTDEV"
301         $XFS_REPAIR_PROG $SCRATCH_OPTIONS $* $SCRATCH_DEV
302 }
303
304 # this test requires the projid32bit feature to be available in mkfs.xfs.
305 #
306 _require_projid32bit()
307 {
308        _scratch_mkfs_xfs_supported -i projid32bit=1 >/dev/null 2>&1 \
309            || _notrun "mkfs.xfs doesn't have projid32bit feature"
310 }
311
312 _require_projid16bit()
313 {
314         _scratch_mkfs_xfs_supported -i projid32bit=0 >/dev/null 2>&1 \
315            || _notrun "16 bit project IDs not supported on $SCRATCH_DEV"
316 }
317
318 # this test requires the crc feature to be available in mkfs.xfs
319 #
320 _require_xfs_mkfs_crc()
321 {
322         _scratch_mkfs_xfs_supported -m crc=1 >/dev/null 2>&1 \
323            || _notrun "mkfs.xfs doesn't have crc feature"
324 }
325
326 # this test requires the xfs kernel support crc feature
327 #
328 _require_xfs_crc()
329 {
330         _scratch_mkfs_xfs -m crc=1 >/dev/null 2>&1
331         _try_scratch_mount >/dev/null 2>&1 \
332            || _notrun "Kernel doesn't support crc feature"
333         _scratch_unmount
334 }
335
336 # this test requires the xfs kernel support crc feature on scratch device
337 #
338 _require_scratch_xfs_crc()
339 {
340         _scratch_mkfs_xfs >/dev/null 2>&1
341         _try_scratch_mount >/dev/null 2>&1 \
342            || _notrun "Kernel doesn't support crc feature"
343         $XFS_INFO_PROG $SCRATCH_MNT | grep -q 'crc=1' || _notrun "crc feature not supported by this filesystem"
344         _scratch_unmount
345 }
346
347 # this test requires the finobt feature to be available in mkfs.xfs
348 #
349 _require_xfs_mkfs_finobt()
350 {
351         _scratch_mkfs_xfs_supported -m crc=1,finobt=1 >/dev/null 2>&1 \
352            || _notrun "mkfs.xfs doesn't have finobt feature"
353 }
354
355 # this test requires the xfs kernel support finobt feature
356 #
357 _require_xfs_finobt()
358 {
359         _scratch_mkfs_xfs -m crc=1,finobt=1 >/dev/null 2>&1
360         _try_scratch_mount >/dev/null 2>&1 \
361            || _notrun "Kernel doesn't support finobt feature"
362         _scratch_unmount
363 }
364
365 # this test requires xfs sysfs attribute support
366 #
367 _require_xfs_sysfs()
368 {
369         attr=$1
370         sysfsdir=/sys/fs/xfs
371
372         if [ ! -e $sysfsdir ]; then
373                 _notrun "no kernel support for XFS sysfs attributes"
374         fi
375
376         if [ ! -z $1 ] && [ ! -e $sysfsdir/$attr ]; then
377                 _notrun "sysfs attribute '$attr' is not supported"
378         fi
379 }
380
381 # this test requires the xfs sparse inode feature
382 #
383 _require_xfs_sparse_inodes()
384 {
385         _scratch_mkfs_xfs_supported -m crc=1 -i sparse > /dev/null 2>&1 \
386                 || _notrun "mkfs.xfs does not support sparse inodes"
387         _scratch_mkfs_xfs -m crc=1 -i sparse > /dev/null 2>&1
388         _try_scratch_mount >/dev/null 2>&1 \
389                 || _notrun "kernel does not support sparse inodes"
390         _scratch_unmount
391 }
392
393 # check that xfs_db supports a specific command
394 _require_xfs_db_command()
395 {
396         if [ $# -ne 1 ]; then
397                 echo "Usage: _require_xfs_db_command command" 1>&2
398                 exit 1
399         fi
400         command=$1
401
402         _scratch_mkfs_xfs >/dev/null 2>&1
403         _scratch_xfs_db -x -c "help" | grep $command > /dev/null || \
404                 _notrun "xfs_db $command support is missing"
405 }
406
407 # Does the filesystem mounted from a particular device support scrub?
408 _supports_xfs_scrub()
409 {
410         local mountpoint="$1"
411         local device="$2"
412
413         if [ -z "$device" ] || [ -z "$mountpoint" ]; then
414                 echo "Usage: _supports_xfs_scrub mountpoint device"
415                 return 1
416         fi
417
418         if [ ! -b "$device" ] || [ ! -e "$mountpoint" ]; then
419                 return 1
420         fi
421
422         test "$FSTYP" = "xfs" || return 1
423         test -x "$XFS_SCRUB_PROG" || return 1
424
425         # Probe for kernel support...
426         $XFS_IO_PROG -c 'help scrub' 2>&1 | grep -q 'types are:.*probe' || return 1
427         $XFS_IO_PROG -c "scrub probe" "$mountpoint" 2>&1 | grep -q "Inappropriate ioctl" && return 1
428
429         # Scrub can't run on norecovery mounts
430         _fs_options "$device" | grep -q "norecovery" && return 1
431
432         return 0
433 }
434
435 # Save a snapshot of a corrupt xfs filesystem for later debugging.
436 _xfs_metadump() {
437         local metadump="$1"
438         local device="$2"
439         local logdev="$3"
440         local compressopt="$4"
441         shift; shift; shift; shift
442         local options="$@"
443         test -z "$options" && options="-a -o"
444
445         if [ "$logdev" != "none" ]; then
446                 options="$options -l $logdev"
447         fi
448
449         $XFS_METADUMP_PROG $options "$device" "$metadump"
450         res=$?
451         [ "$compressopt" = "compress" ] && [ -n "$DUMP_COMPRESSOR" ] &&
452                 $DUMP_COMPRESSOR "$metadump" &> /dev/null
453         return $res
454 }
455
456 # run xfs_check and friends on a FS.
457 _check_xfs_filesystem()
458 {
459         if [ $# -ne 3 ]; then
460                 echo "Usage: _check_xfs_filesystem device <logdev>|none <rtdev>|none" 1>&2
461                 exit 1
462         fi
463
464         extra_mount_options=""
465         extra_log_options=""
466         extra_options=""
467         device=$1
468         if [ -f $device ]; then
469                 extra_options="-f"
470         fi
471
472         local logdev="$2"
473         if [ "$logdev" != "none" ]; then
474                 extra_log_options="-l$logdev"
475                 extra_mount_options="-ologdev=$logdev"
476         fi
477
478         local rtdev="$3"
479         if [ "$rtdev" != "none" ]; then
480                 extra_rt_options="-r$rtdev"
481                 extra_mount_options=$extra_mount_options" -ortdev=$rtdev"
482         fi
483         extra_mount_options=$extra_mount_options" $MOUNT_OPTIONS"
484
485         [ "$FSTYP" != xfs ] && return 0
486
487         type=`_fs_type $device`
488         ok=1
489
490         # Run online scrub if we can.
491         mntpt="$(_is_dev_mounted $device)"
492         if [ -n "$mntpt" ] && _supports_xfs_scrub "$mntpt" "$device"; then
493                 "$XFS_SCRUB_PROG" $scrubflag -v -d -n $mntpt > $tmp.scrub 2>&1
494                 if [ $? -ne 0 ]; then
495                         _log_err "_check_xfs_filesystem: filesystem on $device failed scrub"
496                         echo "*** xfs_scrub $scrubflag -v -d -n output ***" >> $seqres.full
497                         cat $tmp.scrub >> $seqres.full
498                         echo "*** end xfs_scrub output" >> $serqres.full
499                         ok=0
500                 fi
501                 rm -f $tmp.scrub
502         fi
503
504         if [ "$type" = "xfs" ]; then
505                 # mounted ...
506                 mountpoint=`_umount_or_remount_ro $device`
507         fi
508
509         $XFS_LOGPRINT_PROG -t $extra_log_options $device 2>&1 \
510                 | tee $tmp.logprint | grep -q "<CLEAN>"
511         if [ $? -ne 0 ]; then
512                 _log_err "_check_xfs_filesystem: filesystem on $device has dirty log"
513                 echo "*** xfs_logprint -t output ***"   >>$seqres.full
514                 cat $tmp.logprint                       >>$seqres.full
515                 echo "*** end xfs_logprint output"      >>$seqres.full
516
517                 ok=0
518         fi
519
520         # xfs_check runs out of memory on large files, so even providing the test
521         # option (-t) to avoid indexing the free space trees doesn't make it pass on
522         # large filesystems. Avoid it.
523         if [ "$LARGE_SCRATCH_DEV" != yes ]; then
524                 _xfs_check $extra_log_options $device 2>&1 > $tmp.fs_check
525         fi
526         if [ -s $tmp.fs_check ]; then
527                 _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (c)"
528                 echo "*** xfs_check output ***"         >>$seqres.full
529                 cat $tmp.fs_check                       >>$seqres.full
530                 echo "*** end xfs_check output"         >>$seqres.full
531
532                 ok=0
533         fi
534
535         $XFS_REPAIR_PROG -n $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
536         if [ $? -ne 0 ]; then
537                 _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (r)"
538                 echo "*** xfs_repair -n output ***"     >>$seqres.full
539                 cat $tmp.repair                         >>$seqres.full
540                 echo "*** end xfs_repair output"        >>$seqres.full
541
542                 ok=0
543         fi
544         rm -f $tmp.fs_check $tmp.logprint $tmp.repair
545
546         if [ "$ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
547                 local flatdev="$(basename "$device")"
548                 _xfs_metadump "$seqres.$flatdev.check.md" "$device" "$logdev" \
549                         compress >> $seqres.full
550         fi
551
552         # Optionally test the index rebuilding behavior.
553         if [ -n "$TEST_XFS_REPAIR_REBUILD" ]; then
554                 rebuild_ok=1
555                 $XFS_REPAIR_PROG $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
556                 if [ $? -ne 0 ]; then
557                         _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild)"
558                         echo "*** xfs_repair output ***"        >>$seqres.full
559                         cat $tmp.repair                         >>$seqres.full
560                         echo "*** end xfs_repair output"        >>$seqres.full
561
562                         ok=0
563                         rebuild_ok=0
564                 fi
565                 rm -f $tmp.repair
566
567                 $XFS_REPAIR_PROG -n $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
568                 if [ $? -ne 0 ]; then
569                         _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild-reverify)"
570                         echo "*** xfs_repair -n output ***"     >>$seqres.full
571                         cat $tmp.repair                         >>$seqres.full
572                         echo "*** end xfs_repair output"        >>$seqres.full
573
574                         ok=0
575                         rebuild_ok=0
576                 fi
577                 rm -f $tmp.repair
578
579                 if [ "$rebuild_ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
580                         local flatdev="$(basename "$device")"
581                         _xfs_metadump "$seqres.$flatdev.rebuild.md" "$device" \
582                                 "$logdev" compress >> $seqres.full
583                 fi
584         fi
585
586         if [ $ok -eq 0 ]; then
587                 echo "*** mount output ***"             >>$seqres.full
588                 _mount                                  >>$seqres.full
589                 echo "*** end mount output"             >>$seqres.full
590         elif [ "$type" = "xfs" ]; then
591                 _mount_or_remount_rw "$extra_mount_options" $device $mountpoint
592         fi
593
594         if [ $ok -eq 0 ]; then
595                 status=1
596                 if [ "$iam" != "check" ]; then
597                         exit 1
598                 fi
599                 return 1
600         fi
601
602         return 0
603 }
604
605 _check_xfs_test_fs()
606 {
607         TEST_LOG="none"
608         TEST_RT="none"
609         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
610                 TEST_LOG="$TEST_LOGDEV"
611
612         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_RTDEV" ] && \
613                 TEST_RT="$TEST_RTDEV"
614
615         _check_xfs_filesystem $TEST_DEV $TEST_LOG $TEST_RT
616         return $?
617 }
618
619 _require_xfs_test_rmapbt()
620 {
621         _require_test
622
623         if [ "$($XFS_INFO_PROG "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
624                 _notrun "rmapbt not supported by test filesystem type: $FSTYP"
625         fi
626 }
627
628 _require_xfs_scratch_rmapbt()
629 {
630         _require_scratch
631
632         _scratch_mkfs > /dev/null
633         _scratch_mount
634         if [ "$($XFS_INFO_PROG "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
635                 _scratch_unmount
636                 _notrun "rmapbt not supported by scratch filesystem type: $FSTYP"
637         fi
638         _scratch_unmount
639 }
640
641 _xfs_bmapx_find()
642 {
643         case "$1" in
644         "attr")
645                 param="a"
646                 ;;
647         "cow")
648                 param="c"
649                 ;;
650         *)
651                 param="e"
652                 ;;
653         esac
654         shift
655         file="$1"
656         shift
657
658         $XFS_IO_PROG -c "bmap -${param}lpv" "$file" | grep -c "$@"
659 }
660
661 # Reset all xfs error handling attributes, set them to original
662 # status.
663 #
664 # Only one argument, and it's mandatory:
665 #  - dev: device name, e.g. $SCRATCH_DEV
666 #
667 # Note: this function only works for XFS
668 _reset_xfs_sysfs_error_handling()
669 {
670         local dev=$1
671
672         if [ ! -b "$dev" -o "$FSTYP" != "xfs" ]; then
673                 _fail "Usage: reset_xfs_sysfs_error_handling <device>"
674         fi
675
676         _set_fs_sysfs_attr $dev error/fail_at_unmount 1
677         echo -n "error/fail_at_unmount="
678         _get_fs_sysfs_attr $dev error/fail_at_unmount
679
680         # Make sure all will be configured to retry forever by default, except
681         # for ENODEV, which is an unrecoverable error, so it will be configured
682         # to not retry on error by default.
683         for e in default EIO ENOSPC; do
684                 _set_fs_sysfs_attr $dev \
685                                    error/metadata/${e}/max_retries -1
686                 echo -n "error/metadata/${e}/max_retries="
687                 _get_fs_sysfs_attr $dev error/metadata/${e}/max_retries
688
689                 _set_fs_sysfs_attr $dev \
690                                    error/metadata/${e}/retry_timeout_seconds 0
691                 echo -n "error/metadata/${e}/retry_timeout_seconds="
692                 _get_fs_sysfs_attr $dev \
693                                    error/metadata/${e}/retry_timeout_seconds
694         done
695 }
696
697 # Skip if we are running an older binary without the stricter input checks.
698 # Make multiple checks to be sure that there is no regression on the one
699 # selected feature check, which would skew the result.
700 #
701 # At first, make a common function that runs the tests and returns
702 # number of failed cases.
703 _xfs_mkfs_validation_check()
704 {
705         local tmpfile=`mktemp`
706         local cmd="$MKFS_XFS_PROG -f -N -d file,name=$tmpfile,size=1g"
707
708         $cmd -s size=8s >/dev/null 2>&1
709         local sum=$?
710
711         $cmd -l version=2,su=260k >/dev/null 2>&1
712         sum=`expr $sum + $?`
713
714         rm -f $tmpfile
715         return $sum
716 }
717
718 # Skip the test if all calls passed - mkfs accepts invalid input
719 _require_xfs_mkfs_validation()
720 {
721         _xfs_mkfs_validation_check
722         if [ "$?" -eq 0 ]; then
723                 _notrun "Requires newer mkfs with stricter input checks: the oldest supported version of xfsprogs is 4.7."
724         fi
725 }
726
727 # The opposite of _require_xfs_mkfs_validation.
728 _require_xfs_mkfs_without_validation()
729 {
730         _xfs_mkfs_validation_check
731         if [ "$?" -ne 0 ]; then
732                 _notrun "Requires older mkfs without strict input checks: the last supported version of xfsprogs is 4.5."
733         fi
734 }
735
736 # XFS ability to change UUIDs on V5/CRC filesystems
737 #
738 _require_meta_uuid()
739 {
740         # This will create a crc fs on $SCRATCH_DEV
741         _require_xfs_crc
742
743         _scratch_xfs_db -x -c "uuid restore" 2>&1 \
744            | grep -q "invalid UUID\|supported on V5 fs" \
745            && _notrun "Userspace doesn't support meta_uuid feature"
746
747         _scratch_xfs_db -x -c "uuid generate" >/dev/null 2>&1
748
749         _try_scratch_mount >/dev/null 2>&1 \
750            || _notrun "Kernel doesn't support meta_uuid feature"
751         _scratch_unmount
752 }
753
754 # this test requires mkfs.xfs have case-insensitive naming support
755 _require_xfs_mkfs_ciname()
756 {
757         _scratch_mkfs_xfs_supported -n version=ci >/dev/null 2>&1 \
758                 || _notrun "need case-insensitive naming support in mkfs.xfs"
759 }
760
761 # this test requires mkfs.xfs have configuration file support
762 _require_xfs_mkfs_cfgfile()
763 {
764         echo > /tmp/a
765         _scratch_mkfs_xfs_supported -c options=/tmp/a >/dev/null 2>&1
766         res=$?
767         rm -rf /tmp/a
768         test $res -eq 0 || _notrun "need configuration file support in mkfs.xfs"
769 }
770
771 # XFS_DEBUG requirements
772 _require_xfs_debug()
773 {
774         if grep -q "debug 0" /proc/fs/xfs/stat; then
775                 _notrun "Require XFS built with CONFIG_XFS_DEBUG"
776         fi
777 }
778 _require_no_xfs_debug()
779 {
780         if grep -q "debug 1" /proc/fs/xfs/stat; then
781                 _notrun "Require XFS built without CONFIG_XFS_DEBUG"
782         fi
783 }
784
785 # Require that assertions will not crash the system.
786 #
787 # Assertions would always crash the system if XFS assert fatal was enabled
788 # (CONFIG_XFS_ASSERT_FATAL=y).  If a test is designed to trigger an assertion,
789 # skip the test on a CONFIG_XFS_ASSERT_FATAL built XFS by default.  Note:
790 # CONFIG_XFS_ASSERT_FATAL can be disabled by setting bug_on_assert to zero if
791 # we want test to run.
792 _require_no_xfs_bug_on_assert()
793 {
794         if [ -f /sys/fs/xfs/debug/bug_on_assert ]; then
795                 grep -q "1" /sys/fs/xfs/debug/bug_on_assert && \
796                    _notrun "test requires XFS bug_on_assert to be off, turn it off to run the test"
797         else
798                 # Note: Prior to the creation of CONFIG_XFS_ASSERT_FATAL (and
799                 # the sysfs knob bug_on_assert), assertions would always crash
800                 # the system if XFS debug was enabled (CONFIG_XFS_DEBUG=y).  If
801                 # a test is designed to trigger an assertion and the test
802                 # designer does not want to hang fstests, skip the test.
803                 _require_no_xfs_debug
804         fi
805 }
806
807 # Get a metadata field
808 # The first arg is the field name
809 # The rest of the arguments are xfs_db commands to find the metadata.
810 _scratch_xfs_get_metadata_field()
811 {
812         local key="$1"
813         shift
814
815         local grep_key="$(echo "${key}" | tr '[]()' '....')"
816         local cmds=()
817         local arg
818         for arg in "$@"; do
819                 cmds+=("-c" "${arg}")
820         done
821         _scratch_xfs_db "${cmds[@]}" -c "print ${key}" | grep "^${grep_key}" | \
822                 sed -e 's/^.* = //g'
823 }
824
825 # Set a metadata field
826 # The first arg is the field name
827 # The second arg is the new value
828 # The rest of the arguments are xfs_db commands to find the metadata.
829 _scratch_xfs_set_metadata_field()
830 {
831         local key="$1"
832         local value="$2"
833         shift; shift
834
835         local cmds=()
836         local arg
837         for arg in "$@"; do
838                 cmds+=("-c" "${arg}")
839         done
840
841         local wr_cmd="write"
842         _scratch_xfs_db -x -c "help write" | egrep -q "(-c|-d)" && value="-- ${value}"
843         _scratch_xfs_db -x -c "help write" | egrep -q "(-d)" && wr_cmd="${wr_cmd} -d"
844         _scratch_xfs_db -x "${cmds[@]}" -c "${wr_cmd} ${key} ${value}"
845 }
846
847 _scratch_xfs_get_sb_field()
848 {
849         _scratch_xfs_get_metadata_field "$1" "sb 0"
850 }
851
852 _scratch_xfs_set_sb_field()
853 {
854         _scratch_xfs_set_metadata_field "$1" "$2" "sb 0"
855 }
856
857 # Before xfsprogs commit 4222d000ed("db: write via array indexing doesn't
858 # work"), xfs_db command to write a specific AGFL index doesn't work. It's a
859 # bug in a diagnostic tool that is only used by XFS developers as a test
860 # infrastructure, so it's fine to treat it as a infrastructure dependency as
861 # all other _require rules.
862 _require_xfs_db_write_array()
863 {
864         local supported=0
865
866         _require_test
867         touch $TEST_DIR/$seq.img
868         $MKFS_XFS_PROG -d file,name=$TEST_DIR/$seq.img,size=512m >/dev/null 2>&1
869         $XFS_DB_PROG -x -c "agfl 0" -c "write bno[32] 78" $TEST_DIR/$seq.img \
870                 >/dev/null 2>&1
871         $XFS_DB_PROG -x -c "agfl 0" -c "print bno[32]" $TEST_DIR/$seq.img \
872                 | grep -q "bno\[32\] = 78" && supported=1
873         rm -f $TEST_DIR/$seq.img
874         [ $supported -eq 0 ] && _notrun "xfs_db write can't support array"
875 }
876
877 _require_xfs_spaceman_command()
878 {
879         if [ -z "$1" ]; then
880                 echo "Usage: _require_xfs_spaceman_command command [switch]" 1>&2
881                 exit 1
882         fi
883         local command=$1
884         shift
885         local param="$*"
886         local param_checked=0
887         local opts=""
888
889         _require_command "$XFS_SPACEMAN_PROG" "xfs_spaceman"
890
891         testfile=$TEST_DIR/$$.xfs_spaceman
892         touch $testfile
893         case $command in
894         "health")
895                 testio=`$XFS_SPACEMAN_PROG -c "health $param" $TEST_DIR 2>&1`
896                 param_checked=1
897                 ;;
898         *)
899                 testio=`$XFS_SPACEMAN_PROG -c "help $command" $TEST_DIR 2>&1`
900         esac
901
902         rm -f $testfile 2>&1 > /dev/null
903         echo $testio | grep -q "not found" && \
904                 _notrun "xfs_spaceman $command support is missing"
905         echo $testio | grep -q "Operation not supported" && \
906                 _notrun "xfs_spaceman $command failed (old kernel/wrong fs?)"
907         echo $testio | grep -q "Invalid" && \
908                 _notrun "xfs_spaceman $command failed (old kernel/wrong fs/bad args?)"
909         echo $testio | grep -q "foreign file active" && \
910                 _notrun "xfs_spaceman $command not supported on $FSTYP"
911         echo $testio | grep -q "Inappropriate ioctl for device" && \
912                 _notrun "xfs_spaceman $command support is missing (missing ioctl?)"
913         echo $testio | grep -q "Function not implemented" && \
914                 _notrun "xfs_spaceman $command support is missing (missing syscall?)"
915
916         [ -n "$param" ] || return
917
918         if [ $param_checked -eq 0 ]; then
919                 $XFS_SPACEMAN_PROG -c "help $command" | grep -q "^ $param --" || \
920                         _notrun "xfs_spaceman $command doesn't support $param"
921         fi
922 }
923
924 _scratch_get_sfdir_prefix() {
925         local dir_ino="$1"
926
927         for prefix in "u.sfdir3" "u.sfdir2" "u3.sfdir3"; do
928                 if [ -n "$(_scratch_xfs_get_metadata_field \
929                                 "${prefix}.hdr.parent.i4" \
930                                 "inode ${dir_ino}")" ]; then
931                         echo "${prefix}"
932                         return 0
933                 fi
934         done
935         _scratch_xfs_db -c "inode ${dir_ino}" -c 'p' >> $seqres.full
936         return 1
937 }
938
939 _scratch_get_bmx_prefix() {
940         local ino="$1"
941
942         for prefix in "u3.bmx" "u.bmx"; do
943                 if [ -n "$(_scratch_xfs_get_metadata_field \
944                                 "${prefix}[0].startblock" \
945                                 "inode ${ino}")" ]; then
946                         echo "${prefix}"
947                         return 0
948                 fi
949         done
950         _scratch_xfs_db -c "inode ${ino}" -c 'p' >> $seqres.full
951         return 1
952 }
953
954 #
955 # Ensures that we don't pass any mount options incompatible with XFS v4
956 #
957 _force_xfsv4_mount_options()
958 {
959         local gquota=0
960         local pquota=0
961
962         # Can't have group and project quotas in XFS v4
963         echo "$MOUNT_OPTIONS" | egrep -q "(gquota|grpquota|grpjquota=|gqnoenforce)" && gquota=1
964         echo "$MOUNT_OPTIONS" | egrep -q "(\bpquota|prjquota|pqnoenforce)" && pquota=1
965
966         if [ $gquota -gt 0 ] && [ $pquota -gt 0 ]; then
967                 export MOUNT_OPTIONS=$(echo $MOUNT_OPTIONS \
968                         | sed   -e 's/gquota/QUOTA/g'      \
969                                 -e 's/grpquota/QUOTA/g'    \
970                                 -e 's/grpjquota=[^, ]/QUOTA/g' \
971                                 -e 's/gqnoenforce/QUOTA/g' \
972                                 -e "s/QUOTA/defaults/g")
973         fi
974         echo "MOUNT_OPTIONS = $MOUNT_OPTIONS" >>$seqres.full
975 }
976
977 # Find AG count of mounted filesystem
978 _xfs_mount_agcount()
979 {
980         $XFS_INFO_PROG "$1" | grep agcount= | sed -e 's/^.*agcount=\([0-9]*\),.*$/\1/g'
981 }
982
983 # Wipe the superblock of each XFS AGs
984 _try_wipe_scratch_xfs()
985 {
986         local num='^[0-9]+$'
987         local agcount
988         local agsize
989         local dbsize
990
991         # Try to wipe each SB if there's an existed XFS
992         agcount=`_scratch_xfs_get_sb_field agcount 2>/dev/null`
993         agsize=`_scratch_xfs_get_sb_field agblocks 2>/dev/null`
994         dbsize=`_scratch_xfs_get_sb_field blocksize 2>/dev/null`
995         if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
996                 for ((i = 0; i < agcount; i++)); do
997                         $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
998                                 $SCRATCH_DEV >/dev/null;
999                 done
1000         fi
1001
1002         # Try to wipe each SB by default mkfs.xfs geometry
1003         local tmp=`mktemp -u`
1004         unset agcount agsize dbsize
1005         _scratch_mkfs_xfs -N 2>/dev/null | perl -ne '
1006                 if (/^meta-data=.*\s+agcount=(\d+), agsize=(\d+) blks/) {
1007                         print STDOUT "agcount=$1\nagsize=$2\n";
1008                 }
1009                 if (/^data\s+=\s+bsize=(\d+)\s/) {
1010                         print STDOUT "dbsize=$1\n";
1011                 }' > $tmp.mkfs
1012
1013         . $tmp.mkfs
1014         if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
1015                 for ((i = 0; i < agcount; i++)); do
1016                         $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
1017                                 $SCRATCH_DEV >/dev/null;
1018                 done
1019         fi
1020         rm -f $tmp.mkfs
1021 }
1022
1023 _require_xfs_copy()
1024 {
1025         [ -n "$XFS_COPY_PROG" ] || _notrun "xfs_copy binary not yet installed"
1026         [ "$USE_EXTERNAL" = yes ] && \
1027                 _notrun "Cannot xfs_copy with external devices"
1028 }